\subsection{Parallel Timing Systems}
\label{sec:pts}
Next, we model the timing properties of a SPMD-type parallel system as a whole by combining the two
models of Sections~\ref{sec:tafsa} and \ref{sec:tba} into a single \emph{parallel timing system}. 
A \emph{parallel timing system} (PTS) is a tuple $\tuple{\tbaparent,\atfas, \forkreln,\joinreln}$,
where 
\begin{itemize}
\item $\tbaparent=\tba{\Aalpha}{\astates}{\state[0]}{\accept}{\aclks}{\tbareln}{\ireln}{\creln}$ 
is a TBA (used to model the timing properties of the parent process)
\item $\atfas$ is a set $\set{\tbachild_1,...,\tbachild_n}$ of TFAs
(used to model the timing properties of the child processes)
\item $\forkreln\subseteq \reln\times{\atfas}$
 is a \emph{fork} relation (used to model the spawning of child processes)
\item $\joinreln\subseteq \reln\times{\atfas}$
 is a \emph{join} relation (used to model barriers (joins))
 \end{itemize}
A tuple $\tuple{\state[i],\state[j],\aalpha,\atfa}$ in $\forkreln$, with $\atfa\in\atfas$, indicates that an instance of
$\atfa$ is to be ``forked" on the transition 
from $\state[i]$ to $\state[j]$ on symbol $\aalpha$, and this ``fork" is denoted graphically as 
%$\trans[\fork{\atfa}]{\state[i]}{\clock{\aalpha}{}{}}{\state[j]}$,
$\trans {\state[i]}{ \fork{\atfa} }{\state[j]}$,
modeling the spawning of a child process along the transition.
Similarly,
a tuple $\tuple{\state[i],\state[j],\aalpha,\atfa}$ in $\joinreln$ indicates that 
a previously forked instance of
$\atfa$ is to be ``joined" on the transition 
from $\state[i]$ to $\state[j]$ on symbol $\aalpha$.
This ``join" is denoted graphically as 
$\trans {\state[i]} { \join{\atfa} } {\state[j]}$,
modeling the joining along the transition with a previously spawned child process\footnote{
$\symfork$ was chosen as the symbol for `fork', as it graphically resembles a ``fork"; 
$\symjoin$ was chosen as that for `join', as it connotes ``ending" or ``finality".}.
%As usual, we elide empty components. For 
%example, on a transition where the constraint $\constraint$ and timer $\aclk$ are both empty, 
%we write $\trans[\fork{\tbachild_n}]{\state[i]}{\clock{\aalpha}{}{}}{\state[j]}$ instead.

\input{tpbaex1}

In theory, child processes could spawn children of their own (e.g. recursion).
For now, however, we disallow this possibility, as it somewhat complicates the analysis in 
the following section without adding significantly to the expressive power of the model.
The model can be expanded later to allow for arbitrarily nested children of children with the appropriate 
modifications; specifically, TBAs would need to be extended to include their own $\forkreln$ and $\joinreln$
relations, as would the definition of $\delayTFA$ for TBAs.

\input{tpba_consistency}



\endinput
